/*
 * Copyright (c) 2015 Ziver
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package wa.server.plugin.apache;

import wa.server.plugin.WAServiceStatus;
import zutil.osal.app.linux.Ps;
import zutil.io.file.FileUtil;
import zutil.log.LogUtil;
import zutil.osal.OSAbstractionLayer;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

public class ApacheStatus extends WAServiceStatus {
    private static final Logger log = LogUtil.getLogger();
    private static final String PID_FILE = "/var/run/apache2.pid";

    private static OSAbstractionLayer os = OSAbstractionLayer.getInstance();


    @Override
    public String getName() {
        return ApacheService.SERVICE_NAME;
    }

    @Override
    public void start() {
        os.runCommand("service apache2 start");
    }

    @Override
    public void stop() {
        os.runCommand("service apache2 stop");
    }

    @Override
    public ServiceStatusType getStatus() {
        try {
            int pid = Integer.parseInt(
                    FileUtil.getContent(new File(PID_FILE)));
            if(Ps.isRunning(pid))
                return ServiceStatusType.RUNNING;
            return ServiceStatusType.STOPPED;
        }catch(IOException e){
            log.log(Level.WARNING, null, e);
        }
        return ServiceStatusType.UNKNOWN;
    }
}